<?php

/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright (c) ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (2014-02-04, 09:20:57)
 * 
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Grzegorz Draganik <grzegorz@modulesgarden.com>
 */

class Modulesgarden_Gpndata_NotificationsController extends Mage_Core_Controller_Front_Action {
	
	public function indexAction(){
		
		$configValue	= Mage::getStoreConfig('payment/gpndata');
		$configRecValue	= Mage::getStoreConfig('payment/gpndatarecurring');
		
		$configValue['password']	= Mage::helper('core')->decrypt($configValue['password']);
		$configValue['api_key']		= Mage::helper('core')->decrypt($configValue['api_key']);
		$configRecValue['password'] = Mage::helper('core')->decrypt($configRecValue['password']);
		$configRecValue['api_key']	= Mage::helper('core')->decrypt($configRecValue['api_key']);
		
		$response		= Mage::getModel('gpndata/notification_response');
		$xml_string		= $this->getRequest()->getPost('strdata');
//		Mage::log('NOTIFICATION REQUEST: '.$xml_string, null, 'gpndata.log');
		
		try {
			$notification = Modulesgarden_Gpndata_Model_Notification::factory($xml_string);
		
			// Modulesgarden_Gpndata_Model_Notification::isProperIp($_SERVER['REMOTE_ADDR'], $configValue['submit_url'])
			
			$valid = $notification instanceof Modulesgarden_Gpndata_Model_Notification_870 ?
				$notification->isChecksumOk($configRecValue) :
				$notification->isChecksumOk($configValue);
			
			if (!$valid){
				$response
					->setResult('ERROR')
					->setErrorcode(403)
					->setErrormessage('Checksum is not valid');
				
			} else { // notification ok
				$notification->process($response);
				
			}
			
		} catch (Exception $e){
			$response
				->setResult('ERROR')
				->setErrorcode(500)
				->setErrormessage($e->getMessage());
		}
		
		$xml = $response->getXml();
//		Mage::log('NOTIFICATION RESPONSE: '.$xml, null, 'gpndata.log');
		
		header('Content-type: application/xml; charset="utf-8"');
		echo $xml;
		die();
	}
	
}